unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, clMultiStream;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    procedure TestMultiStream;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.TestMultiStream;
var
  Stream: TMultiStream;
  buf: PChar;
begin
  GetMem(buf, 1024);
  Stream := TMultiStream.Create();
  try
     Stream.AddStream(TStringStream.Create('test string '));
     Stream.AddStream(TFileStream.Create('testfile.txt', fmOpenRead));
     ZeroMemory(buf, 1024);
     Stream.Read(buf^, 1024);
     Assert(string(buf) = 'test string test file');
  finally
     FreeMem(buf);
     Stream.Free();
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  TestMultiStream();
  ShowMessage('Done');
end;

end.
